'use strict';

var ua = window.navigator.userAgent;
var cordovaUrl = resRoot + '/Scripts/cordova/' + getPlatform() + '/cordova';

//define(['angular', cordovaUrl, 'common/utils/heart-beat'], function (angular) {
define(['angularAMD', cordovaUrl], function (angularAMD) {

    //var module = angular.module('cordova.service', ['heartBeatService']);
    var module = angular.module('cordova.service', []);

    //module.run(['$rootScope', '$interval', 'heartBeatService', function ($rootScope, $interval, heartBeatService) {
    module.run(['$rootScope', '$interval', function ($rootScope, $interval) {
        var clientDevice = $rootScope.appDevice = $rootScope.appDevice || {};
        var clientBrowser = $rootScope.appBrowser = $rootScope.appBrowser || {};

        ////在线离线检查
        //clientDevice.online = window.navigator.onLine;
        //function checkHearBeat() {
        //    heartBeatService.heartBeat(function (err) {
        //        clientDevice.online = err ? false : true;
        //    });
        //}
        //
        //checkHearBeat();
        //
        //var hearBeatSeconds = parseInt(localStorage['heartBeatSeconds'] || 60);
        //if (hearBeatSeconds)
        //    $interval(checkHearBeat, hearBeatSeconds * 1000);

        // 平台参数
        var platform = getPlatform();
        if (platform == 'android' || platform == 'ios') {
            window.document.addEventListener("deviceready", function () {

                //clientBrowser.isFullscreen = window.browser.isFullScreen && window.browser.isFullScreen();

                var deviceInfo = getDeviceDefault();
                $rootScope.appState.deviceReady = true;
                $rootScope.appDevice = deviceInfo;
                //$rootScope.$apply(function () {
                //});

            }, false);
        } else {
            clientBrowser.isFullscreen = window.browser.isFullScreen && window.browser.isFullScreen();

            getDeviceDefault();
        }

        function getDeviceDefault() {
            var deviceInfo = window.device.getDeviceInfo();
            deviceInfo.DeviceType = getDeviceType();

            angular.extend(clientDevice, deviceInfo);

            //alert(window.cameraScanner);
            //window.cameraScanner.available(function (rtn) {
            //    if (!rtn) {
            //        return console.log("键盘初始化扫描完毕，此设备不支持摄像头扫描");
            //    }
            //    $rootScope.$apply(clientDevice.cameraScannerAvailable = rtn);
            //});
            return deviceInfo;
        }

        // 屏幕相关
        $rootScope.toggleFullscreen = function (cb) {
            if (clientBrowser.isFullscreen) {
                clientBrowser.isFullscreen = false;
                window.browser.fullScreen(clientBrowser.isFullscreen);
            } else {
                clientBrowser.isFullscreen = true;
                window.browser.fullScreen(clientBrowser.isFullscreen);
            }

            cb && cb(null, clientBrowser.isFullscreen);
        };

        window.addEventListener('resize', function () {
            setOrientation();
            setScreenMode();
            $rootScope.$apply(clientDevice);
        }, false);

        setOrientation();
        setScreenMode();

        function setOrientation() {
            var wd = document.documentElement.clientWidth;
            var ht = document.documentElement.clientHeight;
            if (wd > ht) {
                clientDevice.orientation = 'landscape';
            } else {
                clientDevice.orientation = 'portrait';
            }
        }

        function setScreenMode() {
            var screenHandheld = 500,
                screenSTabletP = 710,
                screenSTabletL = 990,
                screenTabletP = 810,
                screenTabletL = 1100,
                screenDesktop = 1200;

            var browserWidth = window.innerWidth;
            if (browserWidth < screenHandheld) clientBrowser.screenMode = 'handheld';
            else if (browserWidth < screenSTabletL && clientBrowser.orientation == 'landscape')
                clientBrowser.screenMode = 'stablet-l';
            else if (browserWidth < screenSTabletP && clientBrowser.orientation == 'portrait')
                clientBrowser.screenMode = 'stablet-p';
            else if (browserWidth < screenTabletL && clientBrowser.orientation == 'landscape')
                clientBrowser.screenMode = 'tablet-l';
            else if (browserWidth < screenTabletP && clientBrowser.orientation == 'portrait')
                clientBrowser.screenMode = 'tablet-p';
            else clientBrowser.screenMode = 'desktop';
            //handheld, stablet-p, stablet-l,tablet-p,tablet-l, desktop
            clientBrowser.isHandheld = clientBrowser.screenMode == 'handheld';
        }
    }]);
});
window.cameraScanner = {
    available: function (cb) {
        setTimeout(function () {
            cb && cb(false);
        }, 0);
    },
    scan: function (cb) {
        setTimeout(function () {
            cb && cb('unsupported', null);
        }, 0);
    }
};


window.browser = {
    fullScreen: toggleFullScreen, // void
    isFullScreen: function () {
        return false;
    },
    exitApp: function () { // void
        open(location, '_self').close()
    },
    openSystemBrowser: function (url) { // void
        window.open(url, '', '', false);
    },
    setAppInstalled: function () {
        localStorage.setItem('appInstalled', true);
    }
};

window.device = {
    takePicture: function (source, targetType, cb) {
        setTimeout(function () {
            cb && cb('unsupported', null);
        }, 0);
    },
    getDeviceInfo: function () {
        return {
            Hardware: '',
            DeviceType: getDeviceType(),
            DeviceId: '',
            OS: getPlatform(),
            Platform: getPlatform(),
            PlatformVersion: getPlatformVersion()
        }
    }
};
function toggleFullScreen() {
    if (!document.fullscreenElement &&    // alternative standard method
        !document.mozFullScreenElement && !document.webkitFullscreenElement && !document.msFullscreenElement) {  // current working methods
        if (document.documentElement.requestFullscreen) {
            document.documentElement.requestFullscreen();
        } else if (document.documentElement.msRequestFullscreen) {
            document.documentElement.msRequestFullscreen();
        } else if (document.documentElement.mozRequestFullScreen) {
            document.documentElement.mozRequestFullScreen();
        } else if (document.documentElement.webkitRequestFullscreen) {
            document.documentElement.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT);
        }
    } else {
        if (document.exitFullscreen) {
            document.exitFullscreen();
        } else if (document.msExitFullscreen) {
            document.msExitFullscreen();
        } else if (document.mozCancelFullScreen) {
            document.mozCancelFullScreen();
        } else if (document.webkitExitFullscreen) {
            document.webkitExitFullscreen();
        }
    }
}
function getPlatformVersion() {
    var version = ua.split(')')[0].split('(')[1];
    var versionArray = version.split(';')
    for (var i in versionArray) {
        if (/Windows NT/.test(versionArray[i])) {
            return versionArray[i].replace('Windows NT ', '').replace(/\s/g, '');
        } else if (/Android/.test(versionArray[i])) {
            return versionArray[i].replace('Android ', '').replace(/\s/g, '');
        } else if (/Mac OS/.test(versionArray[i])) {
            var MacNUm = versionArray[i].replace(/[a-zA-Z]/ig, '').replace(/\s/g, '');
            var version = '';
            var vsArray = MacNUm.split('_')
            for (var i in vsArray) {
                version += vsArray[i] + '.';
            }
            return version.substring(0, version.length - 1)
        }
    }
}

function getDeviceType() {
    var wd = window.screen.width;
    var ht = window.screen.height;
    var minimum = wd > ht ? ht : wd;
    if (!!ua.match(/AppleWebKit.*Mobile/) || !!ua.match(/Windows Phone/) || !!ua.match(/Android/) || !!ua.match(/ios/) || !!ua.match(/MQQBrowser/)) {
        if (ua.indexOf('iPhone') > -1 || ua.indexOf('Android') > -1 && minimum <= 720) {
            return 'handheld'
        } else {
            return 'tablet'
        }
    } else {
        return 'desktop'
    }
}

function getPlatform() {
    var PLAT;
    if (/ntcAndroidBrowser/.exec(ua)) {
        PLAT = 'android';
    } else if (/Android/.exec(ua) || /Crosswalk/.exec(ua)) {
        PLAT = 'android';
    } else if (/ntcIOS/.exec(ua)) {
        PLAT = 'ios';
    } else if (/ntcDeskBrowser/.exec(ua)) {
        PLAT = 'windows';
    } else if (/(BB10)|(PlayBook)|(BlackBerry)/.exec(ua)) {
        PLAT = 'blackberry';
    } else if (/Windows/.exec(ua)) {
        PLAT = 'browser';
    } else if (/Macintosh/.exec(ua)) {
        PLAT = 'browser';
    } else if (/Linux/.exec(ua)) {
        PLAT = 'browser';
    } else if (/X11/.exec(ua)) {
        PLAT = 'browser';
    } else {
        PLAT = 'browser';
    }
    return PLAT;
}



